
assert False, "TODO"

from gurobipy import *

from pipedream.ilp import types as ilp


# def resolve_model( alpha,  seqs, src, dst):
#     m = Model("throughput")
#     delta_vars = dict()
#     for inst in src:
#         for port in dst:
#             delta_vars[( inst, port)] = m.addVar(vtype=GRB.BINARY)
#             m.addConstr(delta_vars[( inst, port)] >= max(alpha[(seq, inst, port)] for seq in seqs))
#     m.update()
#     m.setObjective(quicksum(delta_vars[(inst, port)]  for inst in src for port in dst), GRB.MINIMIZE)
#     m.optimize()
#     if m.status == GRB.OPTIMAL:
#         print("--------------")
#         print("Optimal solution found !")
#         print(delta_vars)

# def resolve_model_through(throughput, seqs, src, dst):
#     m = Model("throughput")
#     # Vars representing connection between instructions and port
#     delta_vars = dict()
#     # vars representing the throughputs obtained for a given sequence and link
#     alpha_vars = dict()
#     for inst in src:
#         for port in dst:
#             delta_vars[( inst, port)] = m.addVar(vtype=GRB.BINARY)
#             for seq in seqs:
#                 alpha_vars[( seq, inst, port)] = m.addVar(vtype=GRB.CONTINUOUS)

#     # These vars represent the throughput obtained in a sequence on a given port
#     rho_vars = dict()
#     for seq in seqs:
#         for port in dst:
#             rho_vars[(seq, port)] = m.addVar(vtype=GRB.CONTINUOUS)
#             m.addConstr(rho_vars[(seq, port)]  <= 1.0)
#     m.update()

#     # Constraints

#     # the sum of all ports throughput on a sequence must be equal to the global
#     # throughput of this sequence
#     for seq in seqs:
#         m.addConstr(quicksum(rho_vars[(seq, port)] for port in dst) == throughput[seq])
#     m.update()

            
#     # if an alpha is non zero, then there must be a connection on this link As
#     # delta are binary variables, we translate that as delta(inst, port) > alpha(seq, inst, port)
#     # for all seq
#     for inst in src:
#         for port in dst:
#             for seq in seqs:
#                 m.addConstr(delta_vars[( inst, port)] >= alpha_vars[(seq, inst, port)] )

#     # For a given sequence, the throughput on a port must be equal to the sum of all alpha
#     # having this port as destination
#     for port in dst:
#         for seq in seqs:
#             m.addConstr(quicksum(alpha_vars[( seq, inst, port)] for inst in
#                 src) == rho_vars[(seq,  port)] )

#     # END Constraints

#     m.update()
#     # Objective
#     # We want the number of connections in the graph
#     m.setObjective(quicksum(delta_vars[(inst, port)]  for inst in src for port in dst), GRB.MINIMIZE)
#     m.optimize()
#     if m.status == GRB.OPTIMAL:
#         print("--------------")
#         print("Optimal solution found !")
#     delta = dict()
#     alpha = dict()
#     throughputs = dict()
#     for (inst, port), value in delta_vars.items():
#         delta[(inst, port)] = delta_vars[(inst, port)].X

#     for (seq, inst, port), value in alpha_vars.items():
#         alpha[(seq, inst, port)] = alpha_vars[(seq, inst, port)].X
#     for (seq, port), value in rho_vars.items():
#         throughputs[(seq, port)] = rho_vars[(seq, port)].X


#     return delta




# def resolve_model_inst_mix(throughput, inst_mix, seqs, src, dst):
#     m = Model("throughput")
#     # Vars representing connection between instructions and port
#     delta_vars = dict()
#     # vars representing the throughputs obtained for a given sequence and link
#     alpha_vars = dict()

#     nb_inst = len(src)
#     for inst in src:
#         for port in dst:
#             delta_vars[( inst, port)] = m.addVar(vtype=GRB.BINARY)
#             for seq in seqs:
#                 alpha_vars[( seq, inst, port)] = m.addVar(vtype=GRB.CONTINUOUS)

#     # These vars represent the throughput obtained in a sequence on a given port
#     rho_vars = dict()
#     rho_vars_inst = dict()
#     for seq in seqs:
#         for port in dst:
#             rho_vars[(seq, port)] = m.addVar(vtype=GRB.CONTINUOUS)
#             m.addConstr(rho_vars[(seq, port)]  <= 1.0)
#     m.update()

#     for seq in seqs:
#         for inst in src:
#             rho_vars_inst[(seq, inst)] = m.addVar(vtype=GRB.CONTINUOUS)

#     # Constraints

#     # the sum of all ports throughput on a sequence must be equal to the global
#     # throughput of this sequence
#     for seq in seqs:
#         m.addConstr(quicksum(rho_vars[(seq, port)] for port in dst) == throughput[seq])
#     m.update()


#     for seq in seqs:
#         for inst in src:
#             m.addConstr(quicksum(alpha_vars[(seq, inst, port)] for port in dst) == rho_vars_inst[(seq, inst)])
#             nb_inst_mix = sum([v for (s, i), v in inst_mix.items() if s is seq])
#             assert nb_inst_mix > 0
#             if (seq, inst) in inst_mix:
#                 m.addConstr(rho_vars_inst[seq, inst] == throughput[seq] * inst_mix[seq,inst] / float(nb_inst_mix))

#     m.update()

            
#     # if an alpha is non zero, then there must be a connection on this link As
#     # delta are binary variables, we translate that as delta(inst, port) > alpha(seq, inst, port)
#     # for all seq
#     for inst in src:
#         for port in dst:
#             for seq in seqs:
#                 m.addConstr(delta_vars[( inst, port)] >= alpha_vars[(seq, inst, port)] )

#     # For a given sequence, the throughput on a port must be equal to the sum of all alpha
#     # having this port as destination
#     for port in dst:
#         for seq in seqs:
#             m.addConstr(quicksum(alpha_vars[( seq, inst, port)] for inst in
#                 src) == rho_vars[(seq,  port)] )

#     # END Constraints

#     m.update()
#     # Objective
#     # We want the number of connections in the graph
#     m.setObjective(quicksum(delta_vars[(inst, port)]  for inst in src for port in dst), GRB.MINIMIZE)
#     m.optimize()
#     if m.status == GRB.OPTIMAL:
#         print("--------------")
#         print("Optimal solution found !")
#     else:
#         raise RuntimeError("solution not found")
#     delta = dict()
#     alpha = dict()
#     throughputs = dict()
#     for (inst, port), value in delta_vars.items():
#         delta[(inst, port)] = delta_vars[(inst, port)].X

#     for (seq, inst, port), value in alpha_vars.items():
#         alpha[(seq, inst, port)] = alpha_vars[(seq, inst, port)].X
#     for (seq, port), value in rho_vars.items():
#         throughputs[(seq, port)] = rho_vars[(seq, port)].X



#     return delta
